#ifndef TRACE_H
#define TRACE_H

/* This file is autogenerated by tracetool, do not edit. */

#include "qemu-common.h"
#include "trace-dtrace.h"

static inline void trace_qemu_malloc(size_t size, void *ptr) {
    if (QEMU_QEMU_MALLOC_ENABLED()) {
        QEMU_QEMU_MALLOC(size, ptr);
    }
}

static inline void trace_qemu_realloc(void *ptr, size_t size, void *newptr) {
    if (QEMU_QEMU_REALLOC_ENABLED()) {
        QEMU_QEMU_REALLOC(ptr, size, newptr);
    }
}

static inline void trace_qemu_free(void *ptr) {
    if (QEMU_QEMU_FREE_ENABLED()) {
        QEMU_QEMU_FREE(ptr);
    }
}

static inline void trace_qemu_memalign(size_t alignment, size_t size, void *ptr) {
    if (QEMU_QEMU_MEMALIGN_ENABLED()) {
        QEMU_QEMU_MEMALIGN(alignment, size, ptr);
    }
}

static inline void trace_qemu_vmalloc(size_t size, void *ptr) {
    if (QEMU_QEMU_VMALLOC_ENABLED()) {
        QEMU_QEMU_VMALLOC(size, ptr);
    }
}

static inline void trace_qemu_vfree(void *ptr) {
    if (QEMU_QEMU_VFREE_ENABLED()) {
        QEMU_QEMU_VFREE(ptr);
    }
}

static inline void trace_virtqueue_fill(void *vq, const void *elem, unsigned int len, unsigned int idx) {
    if (QEMU_VIRTQUEUE_FILL_ENABLED()) {
        QEMU_VIRTQUEUE_FILL(vq, elem, len, idx);
    }
}

static inline void trace_virtqueue_flush(void *vq, unsigned int count) {
    if (QEMU_VIRTQUEUE_FLUSH_ENABLED()) {
        QEMU_VIRTQUEUE_FLUSH(vq, count);
    }
}

static inline void trace_virtqueue_pop(void *vq, void *elem, unsigned int in_num, unsigned int out_num) {
    if (QEMU_VIRTQUEUE_POP_ENABLED()) {
        QEMU_VIRTQUEUE_POP(vq, elem, in_num, out_num);
    }
}

static inline void trace_virtio_queue_notify(void *vdev, int n, void *vq) {
    if (QEMU_VIRTIO_QUEUE_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_QUEUE_NOTIFY(vdev, n, vq);
    }
}

static inline void trace_virtio_irq(void *vq) {
    if (QEMU_VIRTIO_IRQ_ENABLED()) {
        QEMU_VIRTIO_IRQ(vq);
    }
}

static inline void trace_virtio_notify(void *vdev, void *vq) {
    if (QEMU_VIRTIO_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_NOTIFY(vdev, vq);
    }
}

static inline void trace_multiwrite_cb(void *mcb, int ret) {
    if (QEMU_MULTIWRITE_CB_ENABLED()) {
        QEMU_MULTIWRITE_CB(mcb, ret);
    }
}

static inline void trace_bdrv_aio_multiwrite(void *mcb, int num_callbacks, int num_reqs) {
    if (QEMU_BDRV_AIO_MULTIWRITE_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE(mcb, num_callbacks, num_reqs);
    }
}

static inline void trace_bdrv_aio_multiwrite_earlyfail(void *mcb) {
    if (QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL(mcb);
    }
}

static inline void trace_bdrv_aio_multiwrite_latefail(void *mcb, int i) {
    if (QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL(mcb, i);
    }
}

static inline void trace_bdrv_aio_readv(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_READV_ENABLED()) {
        QEMU_BDRV_AIO_READV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_writev(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_WRITEV_ENABLED()) {
        QEMU_BDRV_AIO_WRITEV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_virtio_blk_req_complete(void *req, int status) {
    if (QEMU_VIRTIO_BLK_REQ_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_REQ_COMPLETE(req, status);
    }
}

static inline void trace_virtio_blk_rw_complete(void *req, int ret) {
    if (QEMU_VIRTIO_BLK_RW_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_RW_COMPLETE(req, ret);
    }
}

static inline void trace_virtio_blk_handle_write(void *req, uint64_t sector, size_t nsectors) {
    if (QEMU_VIRTIO_BLK_HANDLE_WRITE_ENABLED()) {
        QEMU_VIRTIO_BLK_HANDLE_WRITE(req, sector, nsectors);
    }
}

static inline void trace_paio_submit(void *acb, void *opaque, int64_t sector_num, int nb_sectors, int type) {
    if (QEMU_PAIO_SUBMIT_ENABLED()) {
        QEMU_PAIO_SUBMIT(acb, opaque, sector_num, nb_sectors, type);
    }
}

static inline void trace_cpu_in(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_IN_ENABLED()) {
        QEMU_CPU_IN(addr, val);
    }
}

static inline void trace_cpu_out(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_OUT_ENABLED()) {
        QEMU_CPU_OUT(addr, val);
    }
}

static inline void trace_balloon_event(void *opaque, unsigned long addr) {
    if (QEMU_BALLOON_EVENT_ENABLED()) {
        QEMU_BALLOON_EVENT(opaque, addr);
    }
}

static inline void trace_apic_local_deliver(int vector, uint32_t lvt) {
    if (QEMU_APIC_LOCAL_DELIVER_ENABLED()) {
        QEMU_APIC_LOCAL_DELIVER(vector, lvt);
    }
}

static inline void trace_apic_deliver_irq(uint8_t dest, uint8_t dest_mode, uint8_t delivery_mode, uint8_t vector_num, uint8_t polarity, uint8_t trigger_mode) {
    if (QEMU_APIC_DELIVER_IRQ_ENABLED()) {
        QEMU_APIC_DELIVER_IRQ(dest, dest_mode, delivery_mode, vector_num, polarity, trigger_mode);
    }
}

static inline void trace_cpu_set_apic_base(uint64_t val) {
    if (QEMU_CPU_SET_APIC_BASE_ENABLED()) {
        QEMU_CPU_SET_APIC_BASE(val);
    }
}

static inline void trace_cpu_get_apic_base(uint64_t val) {
    if (QEMU_CPU_GET_APIC_BASE_ENABLED()) {
        QEMU_CPU_GET_APIC_BASE(val);
    }
}

static inline void trace_apic_mem_readl(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_READL_ENABLED()) {
        QEMU_APIC_MEM_READL(addr, val);
    }
}

static inline void trace_apic_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_WRITEL_ENABLED()) {
        QEMU_APIC_MEM_WRITEL(addr, val);
    }
}

static inline void trace_apic_reset_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_RESET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_RESET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_get_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_GET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_GET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_set_irq(int apic_irq_delivered) {
    if (QEMU_APIC_SET_IRQ_ENABLED()) {
        QEMU_APIC_SET_IRQ(apic_irq_delivered);
    }
}

static inline void trace_vm_state_notify(int running, int reason) {
    if (QEMU_VM_STATE_NOTIFY_ENABLED()) {
        QEMU_VM_STATE_NOTIFY(running, reason);
    }
}

#endif /* TRACE_H */
